## git-delta 0.16.5

=== Makefile ===
build:
	cargo build --release

format:
	git ls-files | grep '\.rs$$' | xargs -P 0 rustfmt

lint:
	cargo clippy

test: unit-test end-to-end-test

unit-test:
	cargo test

end-to-end-test: build
	./tests/test_raw_output_matches_git_on_full_repo_history
	./tests/test_deprecated_options > /dev/null
	./tests/test_navigate_less_history_file

release:
	@make -f release.Makefile release

version:
	@grep version Cargo.toml | head -n1 | sed -E 's,.*version = "([^"]+)",\1,'

hash:
	@version=$$(make version) && \
	printf "$$version-tar.gz %s\n" $$(curl -sL https://github.com/dandavison/delta/archive/$$version.tar.gz | sha256sum -) && \
	printf "delta-$$version-x86_64-apple-darwin.tar.gz %s\n" $$(curl -sL https://github.com/dandavison/delta/releases/download/$$version/delta-$$version-x86_64-apple-darwin.tar.gz | sha256sum -) && \
	printf "delta-$$version-x86_64-unknown-linux-musl.tar.gz %s\n" $$(curl -sL https://github.com/dandavison/delta/releases/download/$$version/delta-$$version-x86_64-unknown-linux-musl.tar.gz | sha256sum -)

BENCHMARK_INPUT_FILE = /tmp/delta-benchmark-input.gitdiff
BENCHMARK_COMMAND = git log -p 23c292d3f25c67082a2ba315a187268be1a9b0ab
benchmark: build
	$(BENCHMARK_COMMAND) > $(BENCHMARK_INPUT_FILE)
	hyperfine --warmup 10 --min-runs 20 \
		'target/release/delta --no-gitconfig < $(BENCHMARK_INPUT_FILE) > /dev/null'

# https://github.com/brendangregg/FlameGraph
flamegraph: build
	$(BENCHMARK_COMMAND) | target/release/delta > /dev/null &
	sample delta | stackcollapse-sample | flamegraph > etc/performance/flamegraph.svg

chronologer:
	chronologer etc/performance/chronologer.yaml

.PHONY: build format lint test unit-test end-to-end-test release version hash benchmark flamegraph chronologer

=== etc/docker/Makefile ===
.PHONY: delta-ubuntu
delta-ubuntu:
	docker build -f ubuntu.Dockerfile -t delta-ubuntu .

=== debian/changelog ===
git-delta (0.16.5-5) unstable; urgency=medium

  * drop patches 2002_ansi_colours 2002_vte,
    obsoleted by Debian package changes;
    tighten build-dependencies for crate vte

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 16 Dec 2023 18:05:19 +0100

git-delta (0.16.5-4) unstable; urgency=medium

  * split patch 1001 into crate-specific 1001_* and 2002_* patches
  * update dh-cargo fork
  * update copyright info: update coverage
  * drop patch 2001_unicode-segmentation.patch,
    obsoleted by Debian package changes
  * update patches 1001_bat 1001_git2;
    update DEP-3 headers;
    bump build-dependencies for crates bat git2;
    relax build-dependency for crate vte;
    closes: bug#1057368, thanks to Peter Michael Green

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Dec 2023 09:33:00 +0100

git-delta (0.16.5-3) unstable; urgency=medium

  * mention unrelated but similarly named package and binary executable
    in long description and README.Debian file;
    closes: bug#1043316, thanks to Carl Suster
  * install theme file below /etc/delta,
    symlinked from below /usr/share/delta;
    add patch 2001
    to list path of theme file within its own usage comment;
    mention theming in README.Debian
  * stop install upstream README in Markdown source format
    (only rendered as plaintext and html)
  * render and install upstream documentation file ARCHITECTURE

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 09 Aug 2023 10:27:30 +0200

git-delta (0.16.5-2) unstable; urgency=medium

  * update dh-cargo fork
  * suggest bash-completion;
    resolve Built-Using and X-Cargo-Built-Using
  * update patch 1001;
    build-depend on package for crate dirs (not dirs-next)

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 Aug 2023 18:10:28 +0200

git-delta (0.16.5-1) experimental; urgency=medium

  [ Jonas Smedegaard ]
  * initial release;
    closes: bug#944028

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 24 Jul 2023 13:01:23 +0200

=== debian/control ===
Source: git-delta
Section: vcs
Priority: optional
Build-Depends:
 cmark-gfm <!nodoc>,
 debhelper-compat (= 13),
 dh-cargo,
 dh-sequence-bash-completion,
 git <!nocheck>,
 help2man <!nodoc>,
 librust-ansi-colours-1+default-dev,
 librust-ansi-term-0.12+default-dev,
 librust-anyhow-1+default-dev,
 librust-atty-0.2+default-dev,
 librust-bat-0.24+regex-onig-dev,
 librust-bitflags-2+default-dev,
 librust-box-drawing-0.1+default-dev,
 librust-bytelines-2+default-dev,
 librust-chrono-0.4+default-dev,
 librust-chrono-humanize-0.2+default-dev,
 librust-clap-4+default-dev,
 librust-clap-4+derive-dev,
 librust-clap-4+error-context-dev,
 librust-clap-4+help-dev,
 librust-clap-4+usage-dev,
 librust-clap-4+wrap-help-dev,
 librust-console-0.15+default-dev,
 librust-ctrlc-3+default-dev,
 librust-dirs-5+default-dev,
 librust-git2-0.18-dev,
 librust-grep-cli-0.1+default-dev,
 librust-itertools-0.10+default-dev,
 librust-lazy-static-1+default-dev,
 librust-palette-0.7+default-dev,
 librust-pathdiff-0.2+default-dev,
 librust-regex-1+default-dev,
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-serde-json-1+default-dev,
 librust-shell-words-1+default-dev,
 librust-smol-str-0.2+default-dev,
 librust-syntect-5+default-dev,
 librust-sysinfo-0.28-dev,
 librust-unicode-segmentation-1+default-dev,
 librust-unicode-width-0.1+default-dev,
 librust-vte-0.11+default-dev,
 librust-xdg-2+default-dev,
 libstring-shellquote-perl,
Maintainer: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/debian/git-delta.git
Vcs-Browser: https://salsa.debian.org/debian/git-delta
Homepage: https://dandavison.github.io/delta/
Rules-Requires-Root: no

Package: git-delta
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 bash-completion,
Built-Using:
 ${cargo:Built-Using},
XB-X-Cargo-Built-Using:
 ${cargo:X-Cargo-Built-Using},
Description: syntax-highlighting pager for git, diff, and grep output
 Code evolves, and we all spend time studying diffs.
 Delta aims to make this both efficient and enjoyable:
 it allows you to make extensive changes
 to the layout and styling of diffs,
 as well as allowing you to stay arbitrarily close
 to the default git/diff output.
 .
 This package provides the executable binary /usr/bin/delta.
 .
 (Unrelated executable binary /usr/bin/git-delta
 is in the package git-extras,
 and unrelated executable binaries
 /usr/bin/multidelta and /usr/bin/singledelta
 are in the package delta.)

=== debian/rules ===
#!/usr/bin/make -f

# use local fork of debcargo and dh-cargo
PATH := $(CURDIR)/debian/dh-cargo/bin:$(PATH)
PERL5LIB = $(CURDIR)/debian/dh-cargo/lib
export PATH PERL5LIB

# generate documentation unless nodoc requested
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DOCS = README.html README.txt ARCHITECTURE.html ARCHITECTURE.txt
MANPAGES = debian/delta.1
endif

%:
	dh $@ --buildsystem=cargo

%.html: %.md
	cmark-gfm $< > $@

%.txt: %.md
	cmark-gfm --to plaintext $< > $@

execute_after_dh_auto_build: $(DOCS)

execute_after_dh_auto_install: $(MANPAGES)

override_dh_installdocs:
	dh_installdocs --all -- $(DOCS)

# prepare zsh completion snippet as specially named file
execute_before_dh_install:
	cp etc/completion/completion.zsh debian/_delta

# build manpages
debian/delta.1: debian/%.1: debian/git-delta/usr/bin/%
	help2man --section 1 --no-info \
		--name "syntax-highlighting pager for git, diff, and grep output" \
		--output $@ $< \
		|| { $< --help; false; }
	perl -i -p -e 's/\e\[[0-9;]*[mM]//g' $@

## git-delta 0.17.0

=== debian/changelog ===
git-delta (0.17.0-5) unstable; urgency=medium

  * no-changes source-only upload to enable testing migration

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 21 Jul 2024 00:32:09 +0200

git-delta (0.17.0-4) experimental; urgency=medium

  * add patch 1001_sysinfo to use newer branch of crate sysinfo;
    bump build-dependency for crate sysinfo
    (see bug#1075991)

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 20 Jul 2024 16:40:41 +0200

git-delta (0.17.0-3) unstable; urgency=medium

  * drop patch 2002_sysinfo,
    obsoleted by Debian packaging changes;
    tighten build-dependencies for crate sysinfo
  * simplify packaging;
    build-depend on dh-sequence-rust
    (not dh-cargo libstring-shellquote-perl)

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 13 Jul 2024 09:52:16 +0200

git-delta (0.17.0-2) unstable; urgency=medium

  * update patches;
    relax build-dependency for crate itertools;
    closes: bug#1072259, thanks to Peter Green
  * set Static-Built-Using (not X-Cargo-Built-Using)
  * declare compliance with Debian Policy 4.7.0
  * update copyright info: fix file path
  * update dh-cargo fork
  * update copyright info: update coverage
  * recommend git;
    closes: bug#1059826, thanks to Christoph Anton Mitterer

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 31 May 2024 07:54:33 +0200

git-delta (0.17.0-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update and unfuzz patches
  * add patch 2002_terminal-colorsaurus
    to avoid not-in-Debian crate terminal-colorsaurus
  * build-depend on packages for crates anstyle-parse clap-complete
    (not atty vte)
  * relax build-dependencies for crates bytelines sysinfo
  * tighten build-dependency for crate bat

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 02 Apr 2024 11:12:49 +0200

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,20 @@
 Build-Depends:
  cmark-gfm <!nodoc>,
  debhelper-compat (= 13),
- dh-cargo,
  dh-sequence-bash-completion,
+ dh-sequence-rust,
  git <!nocheck>,
  help2man <!nodoc>,
  librust-ansi-colours-1+default-dev,
  librust-ansi-term-0.12+default-dev,
+ librust-anstyle-parse-0.2+default-dev,
  librust-anyhow-1+default-dev,
- librust-atty-0.2+default-dev,
+ librust-bat-0.24+minimal-application-dev,
+ librust-bat-0.24+paging-dev,
  librust-bat-0.24+regex-onig-dev,
  librust-bitflags-2+default-dev,
  librust-box-drawing-0.1+default-dev,
- librust-bytelines-2+default-dev,
+ librust-bytelines-2-dev,
  librust-chrono-0.4+default-dev,
  librust-chrono-humanize-0.2+default-dev,
  librust-clap-4+default-dev,
@@ -24,12 +26,13 @@
  librust-clap-4+help-dev,
  librust-clap-4+usage-dev,
  librust-clap-4+wrap-help-dev,
+ librust-clap-complete-4+default-dev,
  librust-console-0.15+default-dev,
  librust-ctrlc-3+default-dev,
  librust-dirs-5+default-dev,
  librust-git2-0.18-dev,
  librust-grep-cli-0.1+default-dev,
- librust-itertools-0.10+default-dev,
+ librust-itertools-dev (<< 0.13),
  librust-lazy-static-1+default-dev,
  librust-palette-0.7+default-dev,
  librust-pathdiff-0.2+default-dev,
@@ -40,14 +43,12 @@
  librust-shell-words-1+default-dev,
  librust-smol-str-0.2+default-dev,
  librust-syntect-5+default-dev,
- librust-sysinfo-0.28-dev,
+ librust-sysinfo-0.30+default-dev,
  librust-unicode-segmentation-1+default-dev,
  librust-unicode-width-0.1+default-dev,
- librust-vte-0.11+default-dev,
  librust-xdg-2+default-dev,
- libstring-shellquote-perl,
 Maintainer: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/git-delta.git
 Vcs-Browser: https://salsa.debian.org/debian/git-delta
 Homepage: https://dandavison.github.io/delta/
@@ -58,12 +59,14 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Recommends:
+ git,
 Suggests:
  bash-completion,
 Built-Using:
  ${cargo:Built-Using},
-XB-X-Cargo-Built-Using:
- ${cargo:X-Cargo-Built-Using},
+Static-Built-Using:
+ ${cargo:Static-Built-Using},
 Description: syntax-highlighting pager for git, diff, and grep output
  Code evolves, and we all spend time studying diffs.
  Delta aims to make this both efficient and enjoyable:

## git-delta 0.18.2

=== Makefile ===
build:
	cargo build --release

format:
	git ls-files | grep '\.rs$$' | xargs -P 0 rustfmt

lint:
	cargo clippy

test: unit-test end-to-end-test

unit-test:
	cargo test

end-to-end-test: build
	./tests/test_raw_output_matches_git_on_full_repo_history
	./tests/test_deprecated_options > /dev/null
	./tests/test_navigate_less_history_file

shell-completion:
	for shell in bash fish zsh; do ./target/release/delta --generate-completion $$shell > etc/completion/completion.$$shell; done

release:
	@make -f release.Makefile release

version:
	@grep version Cargo.toml | head -n1 | sed -E 's,.*version = "([^"]+)",\1,'

BENCHMARK_INPUT_FILE = /tmp/delta-benchmark-input.gitdiff
BENCHMARK_COMMAND = git log -p 23c292d3f25c67082a2ba315a187268be1a9b0ab
benchmark: build
	$(BENCHMARK_COMMAND) > $(BENCHMARK_INPUT_FILE)
	hyperfine --warmup 10 --min-runs 20 \
		'target/release/delta --no-gitconfig < $(BENCHMARK_INPUT_FILE) > /dev/null'

# https://github.com/brendangregg/FlameGraph
flamegraph: build
	$(BENCHMARK_COMMAND) | target/release/delta > /dev/null &
	sample delta | stackcollapse-sample | flamegraph > etc/performance/flamegraph.svg

chronologer:
	chronologer etc/performance/chronologer.yaml

.PHONY: build format lint test unit-test end-to-end-test release shell-completion version benchmark flamegraph chronologer

=== manual/Makefile ===
build:
	mdbook build

init:
	mdbook init --ignore none --title delta

serve:
	mdbook serve

=== debian/changelog ===
git-delta (0.18.2-4) unstable; urgency=medium

  * add patch 1001_bat and update patch 1001_git2
    to accept newer branch;
    bump build-dependencies for crates bat git2;
    closes: bug#1101624, thanks to Lucas Nussbaum and Jeremy Bícha
  * add metadata about upstream project
  * update git-buildpackage config:
    + filter-out potential upstream debian dir
    + simplify usage config
  * update watch file:
    + mangle upstream version
    + improve filename mangling; use Github API

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 06 Apr 2025 15:22:15 +0200

git-delta (0.18.2-3) unstable; urgency=medium

  * tune build flags for hardening and speed

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 20 Jan 2025 12:52:13 +0100

git-delta (0.18.2-2) unstable; urgency=medium

  * update and unfuzz patches;
    bump build-dependency for crate git2;
    closes: bug#1081864,
    thanks to Santiago Vila and Peter Michael Green

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 06 Oct 2024 23:51:07 +0200

git-delta (0.18.2-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update and unfuzz patches;
    tighten build-dependency for crate itertools

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 04 Oct 2024 17:39:09 +0200

git-delta (0.18.1-1) unstable; urgency=medium

  [ upstream ]
  * new release

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 25 Aug 2024 00:23:08 +0200

git-delta (0.18.0-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update and unfuzz patches
  * build-depend on packages for crates insta rstest;
    relax build-dependencies for crates clap sysinfo

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 17 Aug 2024 09:32:55 +0200

=== debian/control ===
--- 
+++ 
@@ -12,9 +12,9 @@
  librust-ansi-term-0.12+default-dev,
  librust-anstyle-parse-0.2+default-dev,
  librust-anyhow-1+default-dev,
- librust-bat-0.24+minimal-application-dev,
- librust-bat-0.24+paging-dev,
- librust-bat-0.24+regex-onig-dev,
+ librust-bat-0.25+minimal-application-dev,
+ librust-bat-0.25+paging-dev,
+ librust-bat-0.25+regex-onig-dev,
  librust-bitflags-2+default-dev,
  librust-box-drawing-0.1+default-dev,
  librust-bytelines-2-dev,
@@ -25,25 +25,28 @@
  librust-clap-4+error-context-dev,
  librust-clap-4+help-dev,
  librust-clap-4+usage-dev,
- librust-clap-4+wrap-help-dev,
  librust-clap-complete-4+default-dev,
  librust-console-0.15+default-dev,
  librust-ctrlc-3+default-dev,
  librust-dirs-5+default-dev,
- librust-git2-0.18-dev,
+ librust-git2-0.20-dev,
  librust-grep-cli-0.1+default-dev,
- librust-itertools-dev (<< 0.13),
+ librust-insta-1+colors-dev,
+ librust-insta-1+default-dev,
+ librust-insta-1+filters-dev,
+ librust-itertools-0.13+default-dev,
  librust-lazy-static-1+default-dev,
  librust-palette-0.7+default-dev,
  librust-pathdiff-0.2+default-dev,
  librust-regex-1+default-dev,
+ librust-rstest-dev (<< 0.21),
  librust-serde-1+default-dev,
  librust-serde-1+derive-dev,
  librust-serde-json-1+default-dev,
  librust-shell-words-1+default-dev,
  librust-smol-str-0.2+default-dev,
  librust-syntect-5+default-dev,
- librust-sysinfo-0.30+default-dev,
+ librust-sysinfo-0.30-dev,
  librust-unicode-segmentation-1+default-dev,
  librust-unicode-width-0.1+default-dev,
  librust-xdg-2+default-dev,

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,14 @@
 #!/usr/bin/make -f
 
-# use local fork of debcargo and dh-cargo
-PATH := $(CURDIR)/debian/dh-cargo/bin:$(PATH)
-PERL5LIB = $(CURDIR)/debian/dh-cargo/lib
-export PATH PERL5LIB
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
+
+# trust upstream optimization level unless explicitly disabled
+ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
+export DEB_CFLAGS_MAINT_STRIP=-O2
+export DEB_CXXFLAGS_MAINT_STRIP=-O2
+endif
 
 # generate documentation unless nodoc requested
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
@@ -12,7 +17,7 @@
 endif
 
 %:
-	dh $@ --buildsystem=cargo
+	dh $@
 
 %.html: %.md
 	cmark-gfm $< > $@

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
repacksuffix=+ds,\
uversionmangle=s/\d\K-([a-z]+)\.?(\d)?/~$1$2/,\
filenamemangle=s/.*?@ANY_VERSION@(@ARCHIVE_EXT@)/@PACKAGE@_$1.orig$2/,\
downloadurlmangle=s!api.github.com/repos/[^/]+/[^/]+/\Kgit/!tarball/!g,\
searchmode=plain,\
dversionmangle=auto \
https://api.github.com/repos/dandavison/delta/git/matching-refs/tags/ \
https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
